From bb0deb46f9bcb33f0addb3ac30a5242b54b322ad Mon Sep 17 00:00:00 2001
From: Thomas JUND <tjund@entrouvert.com>
Date: Wed, 9 Dec 2020 17:06:40 +0100
Subject: [PATCH] new theme: lambersart (#49357)

---
 static/lambersart/_custom.scss              |  95 ++++++++++++++++++++
 static/lambersart/_vars.scss                |  50 +++++++++++
 static/lambersart/config.json               |  17 ++++
 static/lambersart/img/footer-background.png | Bin 0 -> 12375 bytes
 static/lambersart/style.scss                |   6 ++
 5 files changed, 168 insertions(+)
 create mode 100644 static/lambersart/_custom.scss
 create mode 100644 static/lambersart/_vars.scss
 create mode 100644 static/lambersart/config.json
 create mode 100644 static/lambersart/img/footer-background.png
 create mode 100644 static/lambersart/style.scss

diff --git a/static/lambersart/_custom.scss b/static/lambersart/_custom.scss
new file mode 100644
index 00000000..8e1bd3ce
--- /dev/null
+++ b/static/lambersart/_custom.scss
@@ -0,0 +1,95 @@
+%button {
+	font-weight: 600;
+	text-transform: lowercase;
+	font-variant: small-caps;
+}
+
+//
+// HEADER
+//
+body.has-header-background {
+	.site-header {
+		@media ($min-desktop-viewport) {
+			background-size: auto 100%;
+		}
+	}
+}
+div#header {
+	padding: 0;
+}
+h1#logo.has-logo {
+	display: inline-block;
+	background-image: radial-gradient(
+		circle at 10% 80%,
+		white 75%, transparent 90%);
+	@media ($min-desktop-viewport) {
+		background-image: radial-gradient(
+			ellipse at 10% 80%,
+			white 60%, transparent 70%);
+	}
+	background-position: 0 0;
+		a {
+		background-origin: content-box;
+		height: $header-height-mobile;
+		width: $header-height-mobile;
+		padding: 10px;
+		@media ($min-desktop-viewport) {
+			height: $header-height-desktop;
+			width: $header-height-desktop;
+		}
+	}
+}
+// user links
+#toplinks {
+	border: none;
+	box-shadow: none;
+	right: 0;
+	padding: 0.5em 1em;
+	background: hsla(0, 0%, 100%, 0.8);
+	border-radius: 0 0 0 1em;
+
+	a {
+		@media($max-mobile-viewport) {
+			display: block;
+		}
+	}
+}
+
+//
+// NAV
+//
+.gru-nav-wrapper {
+	@media ($max-mobile-viewport) {
+		margin-top: -$nav-menu-side;
+	}
+}
+div.gru-nav > ul {
+	margin: 0;
+}
+
+//
+// PAGE PICTURE
+//
+body.has-picture nav::after {
+	top: 0;
+}
+
+//
+// MAIN
+//
+div#page main {
+	padding-top: 2rem;
+	background-color: $gray-xlight;
+}
+
+//
+// FOOTER
+//
+#footer-wrapper {
+	margin-top: 0;
+	background: url(img/footer-background.png) white;
+
+	.menucell li a {
+		color: $link-color;
+	}
+}
diff --git a/static/lambersart/_vars.scss b/static/lambersart/_vars.scss
new file mode 100644
index 00000000..e5d47dec
--- /dev/null
+++ b/static/lambersart/_vars.scss
@@ -0,0 +1,50 @@
+// colors
+
+$gray-xlight: #f9f9f9;
+$gray-light: #eee;
+$green: #A2C748;
+$red: #EC5F65;
+$blue: #46BFE0;
+$blue-dark: #21809b;
+
+// layout
+$header-height-desktop: 185px;
+$header-height-mobile: 120px;
+
+// Core vars
+$width: 1016px;
+$font-family: barlow, sans-serif;
+$link-color: $blue-dark;
+$font-color: #333;
+$primary-color: $green;
+
+$nav-background: $green;
+$nav-full-width-background: true;
+$nav-active-color: $blue;
+$nav-color: white;
+$nav-menu-side: 40px;
+$nav-button-background: $green;
+$nav-mobile-menu-background: $green;
+$nav-mobile-menu-item-color: white;
+
+$title-color: $blue;
+$title-background: transparent;
+$title-weight: bold;
+$title-transform: uppercase;
+$title-border-bottom: 1px solid $green;
+
+$cell-title-cover-border: false;
+$cell-border: 1px solid $gray-light;
+$cell-entry-border-color: $green;
+$cell-entry-hover-color: white;
+$cell-entry-hover-background: $green;
+$cell-entry-font-weight: 500;
+
+$button-background: $green;
+$button-hover-background: $blue;
+$button-color: white;
+
+$widget-border: 1px solid $green;
+$widget-focus-border: 1px solid $blue;
+
+$footer-color: $font-color;
\ No newline at end of file
diff --git a/static/lambersart/config.json b/static/lambersart/config.json
new file mode 100644
index 00000000..038b9c10
--- /dev/null
+++ b/static/lambersart/config.json
@@ -0,0 +1,17 @@
+{
+  "label": "lambersart",
+  "variables": {
+    "pwa_display": "standalone",
+    "theme_color": "#A2C748",
+    "email_header_asset": "emails:logo"
+  },
+  "settings": {
+    "combo": {
+      "COMBO_ASSET_SLOTS.update": {
+        "header:logo": { "label": "Têtière : logo" },
+        "header:background": { "label": "Têtière : fond" },
+        "emails:logo": {"label": "Emails : logo"}
+      }
+    }
+  }
+}
diff --git a/static/lambersart/img/footer-background.png b/static/lambersart/img/footer-background.png
new file mode 100644
index 0000000000000000000000000000000000000000..4054e6e1fdcaab546da5abb810069fb33cc9890f
GIT binary patch
diff --git a/static/lambersart/style.scss b/static/lambersart/style.scss
new file mode 100644
index 00000000..8565689c
--- /dev/null
+++ b/static/lambersart/style.scss
@@ -0,0 +1,6 @@
+@charset "UTF-8";
+@import '../includes/fonts/barlow';
+
+@import 'vars';
+@import '../includes/publik';
+@import 'custom';
-- 
2.20.1