From 1cbc854e1f4825f031d14b326491153408baec02 Mon Sep 17 00:00:00 2001
From: Nicolas ROCHE <nroche@entrouvert.com>
Date: Wed, 23 Dec 2020 14:26:33 +0100
Subject: [PATCH] saint-denis: add a madis-associations JSON cell (#49717)

---
 static/saint-denis/config.json                | 25 +++++++
 .../combo/json/mgdis-associations.html        | 71 +++++++++++++++++++
 2 files changed, 96 insertions(+)
 create mode 100644 templates/variants/saint-denis/combo/json/mgdis-associations.html

diff --git a/static/saint-denis/config.json b/static/saint-denis/config.json
index 351c8f71d..05d2baad3 100644
--- a/static/saint-denis/config.json
+++ b/static/saint-denis/config.json
@@ -2,12 +2,37 @@
   "label": "Saint-Denis",
   "variables": {
     "theme_color": "#eb612d"
   },
   "settings": {
     "combo": {
       "COMBO_ASSET_SLOTS.update": {
         "header:logo": { "label": "Têtière : logo" }
+      },
+      "JSON_CELL_TYPES.update": {
+        "mgdis-associations": {
+          "name": "mgdis : associations",
+          "url": "https://{{ login }}:{{ password }}@{{ host }}/aides/api/tenants/saintdenis/tiers?userid={{ user_nameid }}",
+          "form": [
+            {"label": "Adresse du serveur", "varname": "host", "required": true},
+            {"label": "Login", "varname": "login", "required": true},
+            {"label": "Mot de passe", "varname": "password", "required": true}
+          ],
+          "varnames": [],
+          "log_errors": false,
+          "cache_duration": 0,
+          "force_async": true,
+          "timeout": 5,
+          "additional-data": [
+            {
+              "key": "json_demandes",
+              "url": "https://{{ login }}:{{ password }}@{{ host }}/aides/api/tenants/saintdenis/demandes?userid={{ user_nameid }}",
+              "cache_duration": 0,
+              "log_errors": false,
+              "timeout": 5
+            }
+          ]
+        }
       }
     }
   }
 }
diff --git a/templates/variants/saint-denis/combo/json/mgdis-associations.html b/templates/variants/saint-denis/combo/json/mgdis-associations.html
new file mode 100644
index 000000000..8ae1f8452
--- /dev/null
+++ b/templates/variants/saint-denis/combo/json/mgdis-associations.html
@@ -0,0 +1,71 @@
+<div>
+  {% if json_status != 200 or json_demandes_status != 200 %}
+  ERREUR : logiciel de gestion des associations indisponible. Réponses transmises :
+  <ul>
+    <li>tiers : <i>{{ json_status }}</i></li>
+    <li>demandes : <i>{{ json_demandes_status }}</i>
+  </ul>
+  {% else %}
+
+  {# Tiers #}
+  {% if not json or json.total == 0 %}
+  <p>
+    Afin de pouvoir réaliser des démarches pour le compte de votre association, il faut préalablement déclarer celle-ci auprès de la Ville de Saint-Denis, une fois cette déclaration effectuée de votre part et la fiche validée par la Ville de Saint-Denis, vous aurez accès aux démarches en ligne.
+  </p>
+  <h3>
+    <a href="https://{{ host }}/aides/#/saintdenis/connecte/F_TDECLARASSO/depot/simple">
+      Déclarer votre association
+    </a>
+  </h3>
+  {% else %}
+  <h2>Votre compte est lié à l'association : <b>{{ json.data.0.raisonSociale }}</b></h2>
+  {% endif %}
+
+
+  {# Demandes #}
+  {% if json_demandes and json_demandes.total > 0 %}
+  <h3>Demandes en cours pour votre association</h3>
+
+  {% for demande in json_demandes.data %}
+  <ul>
+    <li>
+      <a href="{{demande.url}}">{{demande.name}}</a> ({{demande.status}})
+    </li>
+  </ul>
+  {% endfor %}
+  <i>
+    <a href="https://{{ host }}/aides/#/saintdenis/connecte/dashboard/aides/suivreDemandesAides">
+      Accéder au détail de ces demandes
+    </a>
+  </i>
+  {% endif %}
+
+  {# liens vers les démarches #}
+  {% if json and json.total > 0 and json.data.0.status == 'SUPPORTED' and json_demandes and json_demandes.total > 0 %}
+  {% with first_demande=json_demandes.data|dictsort:"datetime"|first %}
+  {% if first_demande.status == 'Clôturée' %}
+
+  <h3>Déposer une nouvelle demande pour le compte de mon association</h3>
+  <ul>
+    <li>
+      <a href="{{ eservices_url }}/organisation-evenement/">
+        Organiser un évènement
+      </a>
+    </li>
+    <li>
+      <a href="https://{{ host }}/aides/#/saintdenis/connecte/dashboard/deposerDemandeAide">
+        Déposer une demande de subvention
+      </a>
+    </li>
+    <li>
+      <a href="https://{{ host }}/aides/#/saintdenis/connecte/dashboard/accueil">
+        Modifier la fiche de mon association
+      </a>
+    </li>
+  </ul>
+  {% endif %}
+  {% endwith %}
+  {% endif %}
+
+{% endif %}
+</div>
-- 
2.29.2